import 'dart:io';

import 'package:flutter/material.dart';
import 'dart:async';

import 'package:gengmei_flutter_plugin/gengmei_flutter_plugin.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  List<String> list = List();
  StreamSubscription listen;

  @override
  void initState() {
    super.initState();
//    GengmeiFlutterPlugin.phoneImages().then((value) {
//      print(value);
//      var value2 = value["IsGengmeiAlbumAllImages"];
//      List<String> temp = List();
//      value2.forEach((item) {
//        temp.add(item.path);
//        print("!!!! ${item.path}");
//      });
//      setState(() {
//        list = temp;
//      });
//    }).whenComplete(() {});
    GengmeiFlutterPlugin.aiCamera().then((value) {
      print("NATIVE CAMERA${value}");
    }).whenComplete(() {});

    //phoneImagesEvent
    listen = GengmeiFlutterPlugin.phoneImagesEvent
        .receiveBroadcastStream()
        .listen(_onEvent, onError: _onError);
  }

  void _onEvent(Object event) {
    var event1 = event as Map;
    var event12 = event1["IsGengmeiAlbumAllImages"] as List;
    event12.forEach((value) {
      print("VALUEEE   $value");
    });
  }

  void _onError(Object error) {}

  @override
  void dispose() {
    super.dispose();
    listen.cancel();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: GridView.builder(
            gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                crossAxisCount: 4,
                crossAxisSpacing: 5,
                mainAxisSpacing: 5,
                childAspectRatio: 1),
            itemCount: list.length,
            itemBuilder: (BuildContext context, int index) {
              if (list[index] == null || list[index].isEmpty) {
                return Container();
              }
              return Container(
                decoration: BoxDecoration(
                    image: DecorationImage(
                        image: FileImage(File(list[index])), fit: BoxFit.cover),
                    borderRadius: BorderRadius.all(Radius.circular(5.0))),
                margin: EdgeInsets.only(left: 8, top: 3, right: 8, bottom: 3),
                height: 100,
                width: 100.0,
              );
            }),
      ),
    );
  }
}
