#import "GengmeiFlutterPlugin.h"
#import <AssetsLibrary/AssetsLibrary.h>
#import <Photos/Photos.h>
#import "Image/AlbumItem.h"
#import "TargetViewController.h"


@interface GengmeiFlutterPlugin ()<UIActionSheetDelegate,UIImagePickerControllerDelegate,UINavigationControllerDelegate> //一定要声明这三个协议，缺一不可
@property(nonatomic)FlutterResult  result;
@property(atomic)int needSize;
@property(nonatomic)int nowSize;
@property(nonatomic)NSMutableDictionary<NSString*,NSMutableArray<NSMutableDictionary<NSString*,NSObject*>*>*>* finalMap;
@property(nonatomic,strong) UIImagePickerController *imagePicker;
@end

@implementation GengmeiFlutterPlugin
NSMutableArray<AlbumItem *> *assetCollectionList;
UIViewController * viewController;
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"gengmei_flutter_plugin"
            binaryMessenger:[registrar messenger]];
  GengmeiFlutterPlugin* instance = [[GengmeiFlutterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
    assetCollectionList = [NSMutableArray array];
    viewController =
    [UIApplication sharedApplication].delegate.window.rootViewController;
    
}


- (void)notificationCenter :(NSNotification *)notification{
    [[[viewController navigationController] navigationBar] setHidden:NO];
    [[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationSlide];
    NSString * path= [notification object];
    self.result(path);
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    self.result=result;
    
  if ([@"scan_image_picker" isEqualToString:call.method]) {
      NSString *mediaType = AVMediaTypeVideo;//读取媒体类型
      AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];//读取设备授权状态
      if(authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied){
          NSString *errorStr = @"应用相机权限受限,请在iPhone的“设置-隐私-相机”选项中，允许好享玩访问你的相机。";
          NSLog(@"相机不可用");
      } else {
          NSLog(@"相机可用");
          [self scanPhone];
      }
  } else if([@"native_camera" isEqualToString:call.method]){
      NSString *mediaType = AVMediaTypeVideo;//读取媒体类型
      AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];//读取设备授权状态
      if(authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied){
          NSString *errorStr = @"应用相机权限受限,请在iPhone的“设置-隐私-相机”选项中，允许好享玩访问你的相机。";
          NSLog(@"相机不可用");
      } else {
          NSLog(@"相机可用");
          [self nativeCamera];
      }
  }else if(@"ai_camera"){
      [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(notificationCenter:) name:@"NSNotificationCenter" object:nil];
      NSString *mediaType = AVMediaTypeVideo;//读取媒体类型
      AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];//读取设备授权状态
      if(authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied){
          NSString *errorStr = @"应用相机权限受限,请在iPhone的“设置-隐私-相机”选项中，允许好享玩访问你的相机。";
          NSLog(@"相机不可用");
      } else {
          NSLog(@"相机可用");
          [self aiCamera];
      }
  }else{
      result(FlutterMethodNotImplemented);
  }
}

-(void)aiCamera{
    [[[viewController navigationController] navigationBar] setHidden:YES];
    [[UIApplication sharedApplication] setStatusBarHidden:YES withAnimation:UIStatusBarAnimationSlide];
    TargetViewController* col=[[TargetViewController alloc]init];
    [viewController presentViewController:col animated:YES completion:nil];
//    Gengmei* gengmei=[Gengmei alloc] ;
//    [Gengmei startAct:viewController];
}

-(void)nativeCamera{
    self.imagePicker = [[UIImagePickerController alloc] init];
    // 设置代理
    self.imagePicker.delegate = self;
    // 是否显示裁剪框编辑（默认为NO），等于YES的时候，照片拍摄完成可以进行裁剪
    self.imagePicker.allowsEditing = NO;
    // 设置照片来源为相机
    self.imagePicker.sourceType = UIImagePickerControllerSourceTypeCamera;
    // 设置进入相机时使用前置或后置摄像头
    self.imagePicker.cameraDevice = UIImagePickerControllerCameraDeviceRear;
    // 展示选取照片控制器
    [viewController presentViewController:self.imagePicker animated:YES completion:nil];
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
    NSString *cacheDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
    NSData *data;
    data= UIImagePNGRepresentation(image);
//    if (UIImagePNGRepresentation(image) == nil){
//        data = UIImageJPEGRepresentation(image, 1);
//    }   else {
//        data = UIImagePNGRepresentation(image);
//    }
    NSString *guid = [[NSProcessInfo processInfo] globallyUniqueString];
    NSString *tmpFile = [NSString stringWithFormat:@"image_picker_%@", guid];
    NSString* tmpPath= [cacheDirectory stringByAppendingPathComponent:tmpFile];
    if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
            dispatch_async(dispatch_get_main_queue(), ^{
                if (self.result!=nil) {
                    self.result(tmpPath);
                }
            });
    } else {
        if (self.result!=nil) {
            self.result(@"");
        }
    }
    [picker dismissViewControllerAnimated:YES completion:nil];
    /* 此处参数 info 是一个字典，下面是字典中的键值 （从相机获取的图片和相册获取的图片时，两者的info值不尽相同）
     * UIImagePickerControllerMediaType; // 媒体类型
     * UIImagePickerControllerOriginalImage; // 原始图片
     * UIImagePickerControllerEditedImage; // 裁剪后图片
     * UIImagePickerControllerCropRect; // 图片裁剪区域（CGRect）
     * UIImagePickerControllerMediaURL; // 媒体的URL
     * UIImagePickerControllerReferenceURL // 原件的URL
     * UIImagePickerControllerMediaMetadata // 当数据来源是相机时，此值才有效
     */
    // 从info中将图片取出，并加载到imageView当中
//    UIImage *image = [info objectForKey:UIImagePickerControllerOriginalImage];
//    self.imageView.image = image;
    //    // 创建保存图像时需要传入的选择器对象（回调方法格式固定）
    //    SEL selectorToCall = @selector(image:didFinishSavingWithError:contextInfo:);
    //    // 将图像保存到相册（第三个参数需要传入上面格式的选择器对象）
    //    UIImageWriteToSavedPhotosAlbum(image, self, selectorToCall, NULL);
}

// 取消选取调用的方法
- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
    if (self.result!=nil) {
        self.result(@"");
    }
    [viewController dismissViewControllerAnimated:YES completion:nil];
}

-(void)scanPhone{
    self.nowSize=0;
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
        self.needSize=0;
        if (self.finalMap==nil) {
            self.finalMap=[NSMutableDictionary dictionary];
        }
        [self.finalMap removeAllObjects];
        [assetCollectionList removeAllObjects];
        [self scanPhoneImage];
        [self copyImg];
    });
}

-(void)scanPhoneImage{
    PHFetchResult<PHAssetCollection *> *favoritesCollection = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeSmartAlbum subtype:PHAssetCollectionSubtypeSmartAlbumFavorites options:NO];
    // 获得相机胶卷
    PHFetchResult<PHAssetCollection *> *assetCollections = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeAlbum subtype:PHAssetCollectionSubtypeSmartAlbumUserLibrary options:NO];
    // 获得全部相片
    PHFetchResult<PHAssetCollection *> *cameraRolls = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeSmartAlbum subtype:PHAssetCollectionSubtypeSmartAlbumUserLibrary options:NO];
    
    for (PHAssetCollection *collection in cameraRolls) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        if (model.collectionNumber !=0) {
            [assetCollectionList addObject:model];
        }
    }
    
    for (PHAssetCollection *collection in favoritesCollection) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        if (model.collectionNumber !=0) {
            [assetCollectionList addObject:model];
        }
    }
    
    for (PHAssetCollection *collection in assetCollections) {
        AlbumItem *model = [[AlbumItem alloc] init];
        model.collection = collection;
        
        if (model.collectionNumber!=0) {
            [assetCollectionList addObject:model];
        }
    }
    for (AlbumItem* item in assetCollectionList) {
        self.needSize+=[item collectionNumber];
    }
}

-(void) copyImg{
    NSString *cacheDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    NSFileManager *fileManager = [NSFileManager defaultManager];
    for (int j=0; j<assetCollectionList.count; j++) {
        AlbumItem * item=assetCollectionList[j];
        PHFetchResult<PHAsset *> * assetResult =[item assets];
        NSLog(@"09090909090  %d  %d",[assetResult count],self.needSize);
        for (int i=0; i<[assetResult count]; i++) {
            __block NSString* docName=[item collectionTitle];
            PHAsset * assets=[assetResult objectAtIndex:i];
//            if (assets.mediaType != PHAssetMediaTypeVideo){
            PHImageRequestOptions *imageRequestOption = [[PHImageRequestOptions alloc] init];
            imageRequestOption.synchronous =YES;
            int picWidth=[assets pixelWidth];
            int picHeight=[assets pixelHeight];
            float scareSize=1;
//            if (picWidth>4000) {
//                scareSize=480.0/picWidth;
//            }else if(picWidth>3000){
//                scareSize=600.0/picWidth;
//            }else if (picWidth>1024) {
//                scareSize=1;
//            }
            scareSize=340.0/picWidth;
            NSLog(@"SCARESIZE  %d",picWidth);
            CGSize size=CGSizeMake(picWidth*scareSize, picHeight*scareSize);
            imageRequestOption.networkAccessAllowed = YES;
                [[PHImageManager defaultManager] requestImageForAsset:assets targetSize:size contentMode:PHImageContentModeDefault options:imageRequestOption resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
                    //                NSLog(@"INITTT___))))00000  %d   %d  %@",i,[assetResult count],info);
//                    NSURL * url = [info objectForKey:@"PHImageFileURLKey"];
//                    UIImage *getImage = [UIImage imageWithContentsOfFile:file];
                    NSData *data;
                    if (UIImagePNGRepresentation(result) == nil){
                        data = UIImageJPEGRepresentation(result, 1);
                    }   else {
                        data = UIImagePNGRepresentation(result);
                    }
                    NSString *tmpPath;
                    NSString* newString1=[NSString stringWithFormat:@"i%@",data];
                    if ([newString1 length]>5000) {
                        NSString *temp = [newString1 stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
                        NSString *text = [temp stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet ]];
                        NSString *string1=[text substringWithRange:NSMakeRange([text length]-2000,100)];
                        tmpPath=[cacheDirectory stringByAppendingPathComponent:string1];
                        
                        if ([fileManager fileExistsAtPath:tmpPath]==YES) {
                            self.nowSize++;
                            NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
                            [queryItemDict setObject:tmpPath forKey:@"path"];
                            NSMutableArray * arr=self.finalMap[docName];
                            if (arr==nil) {
                                self.finalMap[docName]=[NSMutableArray array];
                                [self.finalMap[docName] addObject:queryItemDict];
                            }else{
                                [self.finalMap[docName] addObject:queryItemDict];
                            }
                            NSLog(@"SIZEEE  %d %d ",self.nowSize,self.needSize);
                            if (self.nowSize==self.needSize) {
                                NSLog(@"OKKKKKK");
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    self.result(self.finalMap);
                                });
                            }
                        }else{
                            NSLog(@"File NotExists!!! %@",tmpPath);
                            if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
                                NSLog(@"result  %@",tmpPath);
                                self.nowSize++;
                                NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
                                [queryItemDict setObject:tmpPath forKey:@"path"];
                                NSMutableArray * arr=self.finalMap[docName];
                                if (arr==nil) {
                                    self.finalMap[docName]=[NSMutableArray array];
                                    [self.finalMap[docName] addObject:queryItemDict];
                                }else{
                                    [self.finalMap[docName] addObject:queryItemDict];
                                }
                                
                                NSLog(@"SIZEEE  %d %d ",self.nowSize,self.needSize);
                                if (self.nowSize==self.needSize) {
                                    NSLog(@"OKKKKKK");
                                    dispatch_async(dispatch_get_main_queue(), ^{
                                        self.result(self.finalMap);
                                    });
                                }
                            } else {
                                NSLog(@"ERRORRRR  ");
                                self.needSize--;
                            }
                        }
                    }else{
                        NSLog(@"File TOO LOw？？？？ !!! %@",tmpPath);
                        NSString *guid = [[NSProcessInfo processInfo] globallyUniqueString];
                        NSString *tmpFile = [NSString stringWithFormat:@"image_picker_%@", guid];
                        tmpPath= [cacheDirectory stringByAppendingPathComponent:tmpFile];
                        if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
                            NSLog(@"result  %@",tmpPath);
                            self.nowSize++;
                            NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
                            [queryItemDict setObject:tmpPath forKey:@"path"];
                            NSMutableArray * arr=self.finalMap[docName];
                            if (arr==nil) {
                                self.finalMap[docName]=[NSMutableArray array];
                                [self.finalMap[docName] addObject:queryItemDict];
                            }else{
                                [self.finalMap[docName] addObject:queryItemDict];
                            }
                            NSLog(@"SIZEEE  %d %d ",self.nowSize,self.needSize);
                            if (self.nowSize==self.needSize) {
                                NSLog(@"OKKKKKK");
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    self.result(self.finalMap);
                                });
                            }
                        } else {
                            NSLog(@"ERRORRRR  ");
                            self.needSize--;
                        }
                    }
                }];
        }
    }
}

- (NSMutableDictionary*)useToFetchCollection {
    NSMutableDictionary* queryItemDict = [NSMutableDictionary dictionary];
    PHFetchResult<PHAssetCollection *> * collectionResult = [PHAssetCollection fetchAssetCollectionsWithType:PHAssetCollectionTypeMoment subtype:PHAssetCollectionSubtypeSmartAlbumFavorites options:nil];
    
    if (collectionResult.count == 0) {
        return queryItemDict;
    }
    PHFetchOptions *option = [[PHFetchOptions alloc] init];
    //ascending 为YES时，按照照片的创建时间升序排列;为NO时，则降序排列
    option.sortDescriptors = @[[NSSortDescriptor sortDescriptorWithKey:@"creationDate" ascending:YES]];
    PHAssetCollection* item=[collectionResult objectAtIndex:1];
    
    
    [collectionResult enumerateObjectsWithOptions:option usingBlock:^(PHAssetCollection * _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
        NSLog(@"%@--%@--%@", obj.localIdentifier, obj.localizedTitle,obj);
        PHFetchResult<PHAsset *> * assetResult = [PHAsset fetchAssetsInAssetCollection:obj options:NO];
        NSLog(@"INITTT  %d",collectionResult.count);
        //HashMap<String, ArrayList<HashMap<String, Any>>>
        for (int i=0; i<[assetResult count]; i++) {
            PHAsset * assets=[assetResult objectAtIndex:i];
            NSArray* tempArray=[NSArray array];
            if (assets.mediaType != PHAssetMediaTypeVideo){
                
            }
            
        
            
            [[PHImageManager defaultManager] requestImageForAsset:assets targetSize:PHImageManagerMaximumSize contentMode:PHImageContentModeDefault options:nil resultHandler:^(UIImage * _Nullable result, NSDictionary * _Nullable info) {
//                NSLog(@"INITTT___))))00000  %d   %d  %@",i,[assetResult count],info);
                NSURL * url = [info objectForKey:@"PHImageFileURLKey"];
                NSLog(@"INITTT___))))00000 %@",url);
                NSData *data = [NSData dataWithContentsOfURL:url];
                UIImage* image = [UIImage imageWithData:data];
//                CGSize size;
//                if(image)
//                {
//                    size = image.size;
//                }
//                NSLog(@"INFO  %d",size);
                NSString *guid = [[NSProcessInfo processInfo] globallyUniqueString];
                NSString *tmpFile = [NSString stringWithFormat:@"image_picker_%@.JPG", guid];
                //            NSString *tmpDirectory = NSHomeDirectory();
                NSString *tmpDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
                //            NSString *tmpDirectory = NSTemporaryDirectory();
                NSString *tmpPath = [tmpDirectory stringByAppendingPathComponent:tmpFile];
                if ([[NSFileManager defaultManager] createFileAtPath:tmpPath contents:data attributes:nil]) {
                    NSLog(@"result  %@",tmpPath);
                } else {
                    NSLog(@"ERRORRRR  ");
                }
                //            NSLog(@"YEEEEEEE %@",url);
            }];
        }
    }];
    return queryItemDict;
}

- (void) findAllFiles{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    //在这里获取应用程序Documents文件夹里的文件及文件夹列表
//    NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
//            NSString *documentDir = [documentPaths objectAtIndex:0];
//    NSString *tmpDirectory = NSTemporaryDirectory();
//     NSString *tmpDirectory = NSHomeDirectory();
    
    NSString *tmpDirectory = [NSSearchPathForDirectoriesInDomains(NSCachesDirectory, NSUserDomainMask, YES) firstObject];
    NSError *error = nil;
     NSArray *fileList = [[NSArray alloc] init];
    //fileList便是包含有该文件夹下所有文件的文件名及文件夹名的数组
            fileList = [fileManager contentsOfDirectoryAtPath:tmpDirectory error:&error];
    
    
    NSMutableArray *dirArray = [[NSMutableArray alloc] init];

    //在上面那段程序中获得的fileList中列出文件夹名
            for (NSString *file in fileList) {
                        NSString *path = [tmpDirectory stringByAppendingPathComponent:file];
                        NSLog(@"patH!!!  %@",path);
                }
}

@end
